import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.sql.*;

/**
 * View principal de la aplicacion
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AppView extends WindowAdapter {
    private JFrame fr = new JFrame("SISTEMA FACTURACION");
    private JMenuBar mb = new JMenuBar();
    private JMenu mcli = new JMenu("Cliente");
    private JMenu mpro = new JMenu("Producto");
    private JMenu mfac = new JMenu("Factura");
    private JMenuItem micli1 = new JMenuItem("Alta");
    private JMenuItem mipro1 = new JMenuItem("Alta");
    private JMenuItem mifac1 = new JMenuItem("Nueva Factura");
    private Login log = null;
    private JPanel pNorth = new JPanel();
    private JPanel pSouth = new JPanel();
    private JPanel pEast = new JPanel();
    private JPanel pWest = new JPanel();
    private JPanel pCenter = new JPanel();
    

    /**
     * Constructor for objects of class AppView
     */
    public AppView() {
    }
    public AppView(Login l) {
        log = l;
        //
        // agrego menu items a menues
        mcli.add(micli1);
        mpro.add(mipro1);
        mfac.add(mifac1);
        // agrego menues a menu bar
        mb.add(mcli);
        mb.add(mpro);
        mb.add(mfac);
        fr.getContentPane().add("North",pNorth);
        fr.getContentPane().add("South",pSouth);
        fr.getContentPane().add("East",pEast);
        fr.getContentPane().add("West",pWest);
        fr.getContentPane().add("Center",pCenter);
        // indico menu del JFrame
        fr.setJMenuBar(mb);
        
        // initialise instance variables
        fr.addWindowListener(this);
        micli1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("presiono alta de cliente!");
                removeComponent();
                JTextField txtCodigo = new JTextField("");
                JTextField txtDescr = new JTextField("");
                JTextField txtSaldo = new JTextField("0.0");
                JLabel lblCodigo = new JLabel("Codigo");
                JLabel lblDescr = new JLabel("Descripcion");
                JLabel lblSaldo = new JLabel("Saldo");
                JButton btn = new JButton("Grabar");
                JPanel pfrm = new JPanel(new SpringLayout());
                lblCodigo.setLabelFor(txtCodigo);
                lblDescr.setLabelFor(txtDescr);
                lblSaldo.setLabelFor(txtSaldo);
                pfrm.add(lblCodigo);
                pfrm.add(txtCodigo);
                pfrm.add(lblDescr);
                pfrm.add(txtDescr);
                pfrm.add(lblSaldo);
                pfrm.add(txtSaldo);
                pfrm.add(new JLabel(""));
                pfrm.add(btn);

                //
                txtCodigo.setEnabled(false);
                try {
                    ResultSet rs = DataIO.getResultSet("SELECT COALESCE(MAX(IDC)+1,1) FROM TBL_CLIENTE");
                    if ( rs.next() ) {
                        txtCodigo.setText(rs.getString(1));
                    }
                    rs.close();
                } catch(SQLException sqle) {
                    txtCodigo.setText("1");
                }
                
                // events
                btn.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        //validar
                        if ( txtDescr.getText().length() < 1 ) {
                            JOptionPane.showMessageDialog(null, "Debe Ingresar una descripcion", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                            txtDescr.requestFocus();
                            return;
                        }
                        try {
                            Double d = new Double(txtSaldo.getText());
                            if ( d < 0 ) {
                                JOptionPane.showMessageDialog(null, "Debe Ingresar un saldo mayor que cero", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                                txtSaldo.requestFocus();
                                return;
                            }
                        }catch(NumberFormatException nfe) {
                            JOptionPane.showMessageDialog(null, "["+txtSaldo.getText()+"] no es un numero!", "Error de Validacion", JOptionPane.ERROR_MESSAGE);
                            txtSaldo.requestFocus();
                            return;
                        }
                        //insertar cliente en b.d.
                        
                        if ( DataIO.executeQuery("INSERT INTO TBL_CLIENTE(IDC,DESCR,SALDO) VALUES("+txtCodigo.getText()+",'"+txtDescr.getText()+"',"+txtSaldo.getText()+")") ) {
                            DataIO.doCommit();
                            JOptionPane.showMessageDialog(null, "Cliente dado de Alta Ok!", "Info", JOptionPane.INFORMATION_MESSAGE);
                        } else {
                            JOptionPane.showMessageDialog(null, "Error ["+DataIO.getErrorMessages()+"] al intentar dar de alta Cliente!", "Error BD", JOptionPane.ERROR_MESSAGE);
                        }
                    }
                });
                
                //Lay out the panel.
                SpringUtilities.makeCompactGrid(pfrm,
                                                4, 2, //rows, cols
                                                6, 6, //initX, initY
                                                6, 6);//xPad, yPad
                                                
                pCenter.add(pfrm);
                // refresh
                fr.invalidate();
                fr.validate();
                
            }
        });
        
        fr.setLocationRelativeTo(null); // centrado
        // PASO 7 CONFIGURAR EL TAMA#O DEL CONTENEDOR
        fr.setSize(500,400);
        // PASO 8 HACER EL CONTENEDOR VISIBLE
        fr.setVisible(true);
    }
    
    // windows events que nos interesan
    // sobre-escribo metodo windowClosed()
    @Override
    public void windowClosing(WindowEvent e) {
         log.cierroAplicacion();
    }

    private void removeComponent() {
        pNorth.removeAll();
        pSouth.removeAll();
        pEast.removeAll();
        pWest.removeAll();
        pCenter.removeAll();
    }
}
